#include "String.h"// In LibStock
#include "Time.h"//In LibStock
#include "SoftMax7219.h"//In LibStock
#include "SoftW5100.h"//In LibStock

//Software Ethernet Hardware Pins
sfr sbit SOFTWARE_W5100_SCS at RB0_bit;
sfr sbit SOFTWARE_W5100_SDI at RB1_bit;
sfr sbit SOFTWARE_W5100_SDO at RB2_bit;
sfr sbit SOFTWARE_W5100_SCK at RB3_bit;
sfr sbit SOFWTARE_W5100_RESET at RB4_bit;
sfr sbit SOFTWARE_W5100_SCS_DIRECTION at TRISB0_bit;
sfr sbit SOFTWARE_W5100_SDI_DIRECTION at TRISB1_bit;
sfr sbit SOFTWARE_W5100_SDO_DIRECTION at TRISB2_bit;
sfr sbit SOFTWARE_W5100_SCK_DIRECTION at TRISB3_bit;
sfr sbit SOFWTARE_W5100_RESET_DIRECTION at TRISB4_bit;
//

//Software Max7219 HardWare Pins
sfr sbit MAX7219_SDO at RB5_bit;
sfr sbit MAX7219_SDI at RB6_bit;
sfr sbit MAX7219_SCK at RB7_bit;
sfr sbit MAX7219_CS at RC0_bit;
sfr sbit MAX7219_SDO_DIRECTION at TRISB5_bit;
sfr sbit MAX7219_SDI_DIRECTION at TRISB6_bit;
sfr sbit MAX7219_SCK_DIRECTION at TRISB7_bit;
sfr sbit MAX7219_CS_DIRECTION at TRISC0_bit;
//

char IpAdd[]={192,168,1,15};//Local Ip
char Subnet[]={255,255,255,0};//Subnet Mask
char DefGateWay[]={192,168,1,1};//Default Gateway Routers Ip
char Mac[]={0x00, 0x14, 0xA5, 0x76, 0x19, 0x3f};//MAC Address

char ReqBuff[20];//Request Buffer

//WebPage Part1
const char WebPagePart1[]=
"HTTP/1.1 200 OK\nContent-Type: text/html\n\n\
<html>\
<head>\
<title>Project Web Page</title>\
</head>\
<body>\
<h1 align=center>LOCAL TIME : ";

//WebPage Part2
const char WebPagePart2[]=
"</h1>\
<form action=\"/r\" method=\"get\">\
<h1 align=center><input type=\"submit\" value=\"Refresh Time\"></h1>\
</form>\
<form action=\"/s\" method=\"get\">\
<h1 align=center><input type=\"text\" name=\"t1\"></h1>\
<h1 align=center><input type=\"submit\" value=\"Change Display\"></h1>\
</form>\
</body>\
</html>";



void ProcessTcpRequest(char* Remote_Ip, char* Remote_Mac, unsigned int Remote_Port, unsigned int Local_port, unsigned int RequestLength)
{
  Soft_W5100_Get_Request(ReqBuff,20);//Read The Request
  //if r means refresh and display time
  if(ReqBuff[5]=='r')
  {
   Time.Update();//Read Time And Update Time Buffers
   Soft_W5100_Write_ConstPage(WebPagePart1,127);//Write First Part
   SendPage();//Send It
   Soft_W5100_Write_Page(Time.FormatedTime,5);//Write Time
   SendPage();//Send It
   Soft_W5100_Write_ConstPage(WebPagePart2,277);//Write Last Part
   SendPage();//Send It
  }
  //if s Means Seven Segment Display
  else if(ReqBuff[5]=='s')
  {
   SoftDisplay.Print((unsigned int)ReqBuff[10]-48);//Get The Char Value
   Soft_W5100_Write_ConstPage(WebPagePart1,127);//Write Page 1
   SendPage();//Send It
   Soft_W5100_Write_ConstPage(WebPagePart2,277);//Write Page 2
   SendPage();//Send It
  }
  //Case Default Request
  else {
   Soft_W5100_Write_ConstPage(WebPagePart1,127);//Write Page 1
   SendPage();//Send It
   Soft_W5100_Write_ConstPage(WebPagePart2,277);//Write Page 2
   SendPage();//Send It
  }

}

void main() 
{
 InitTime();//Initialize DS1307 Time Lib
 SoftDisplay.Init();//Initialize SoftWare 7-Segment MAX7219
 Soft_W5100_Hardware_Init();//Initialize Wiznet Module Software Spi
 Soft_W5100_Init(IpAdd,Subnet,DefGateWay,Mac);//Initialize Module With Network Parameters
 SoftDisplay.Print(0);//Print An Initial Value
 while(1)
 {
   Soft_W5100_UpdateSocketStatus();//Update The Socket For Getting Requests
 }

}